import Router from '@ember/routing/router';
import type RouterService from '@ember/routing/router-service';
import { Promise } from 'rsvp';
declare class Scheduler {
    isIdle: boolean;
}
declare const scheduler: Scheduler;
export default scheduler;
/**
 * Initializes the top level promise that initiates the post-render work.
 *
 * @public
 * @function
 */
export declare function beginTransition(): void;
/**
 * Initiates the post-render work.
 *
 * @public
 * @function
 */
export declare function endTransition(): void;
/**
 * Connects the router's transition events to
 * app scheduler's work.
 *
 * @public
 * @function
 *
 * @param {RouterService|Router} router An instance of a RouterService or an Ember Router.
 */
export declare function setupRouter(router: RouterService | Router): void;
/**
 * Resets the state of app scheduler's top-level scheduled work promise.
 *
 * @public
 * @function
 */
export declare function reset(): void;
/**
 * This promise, when resolved, approximates after content is painted.
 *
 * @public
 * @function
 * @return {Promise} The scheduled work promise.
 */
export declare function whenRouteIdle(): Promise<any>;
/**
 * Allows for tests to pause until the scheduled work
 * promise is completed.
 *
 * @public
 * @function
 * @return {Promise} The scheduled work promise.
 */
export declare function routeSettled(): Promise<any>;
